
#pragma once
#include "definitions.h"
#include "enums_inner.h"
#ifdef __cplusplus
extern "C"
{
#endif

extern ForexConnectC FXCHandle Transport_createSession();
extern ForexConnectC void Transport_setProxy(const char *host, int port, const char *user, const char *password);
extern ForexConnectC void Transport_setCAInfo(const char *caFilePath);
extern ForexConnectC void Transport_setNumberOfReconnections(const unsigned int iNumber);
extern ForexConnectC void Transport_setApplicationID(const char *appID);
extern ForexConnectC void Transport_getApplicationID(char *appID, size_t *len);
extern ForexConnectC bool LoginRules_isTableLoadedByDefault(FXCHandle instance, O2GTable table);
extern ForexConnectC FXCHandle LoginRules_getTableRefreshResponse(FXCHandle instance, O2GTable table);
extern ForexConnectC FXCHandle LoginRules_getSystemPropertiesResponse(FXCHandle instance);
extern ForexConnectC FXCHandle LoginRules_getPermissionChecker(FXCHandle instance);
extern ForexConnectC FXCHandle LoginRules_getTradingSettingsProvider(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateMarketOpenOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeMarketOpenOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteMarketOpenOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateMarketCloseOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeMarketCloseOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteMarketCloseOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateEntryOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeEntryOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteEntryOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateStopLimitOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeStopLimitOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteStopLimitOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canRequestQuote(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canAcceptQuote(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteQuote(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateOCO(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateOTO(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canJoinToNewContingencyGroup(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canJoinToExistingContingencyGroup(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canRemoveFromContingencyGroup(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeOfferSubscription(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateNetCloseOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeNetCloseOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteNetCloseOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canCreateNetStopLimitOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canChangeNetStopLimitOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canDeleteNetStopLimitOrder(FXCHandle instance, const char *instrument);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseDynamicTrailingForStop(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseDynamicTrailingForLimit(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseDynamicTrailingForEntryStop(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseDynamicTrailingForEntryLimit(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseFluctuateTrailingForStop(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseFluctuateTrailingForLimit(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseFluctuateTrailingForEntryStop(FXCHandle instance);
extern ForexConnectC O2GPermissionStatus PermissionChecker_canUseFluctuateTrailingForEntryLimit(FXCHandle instance);
extern ForexConnectC int TradingSettingsProvider_getCondDistStopForTrade(FXCHandle instance, const char *instrument);
extern ForexConnectC int TradingSettingsProvider_getCondDistLimitForTrade(FXCHandle instance, const char *instrument);
extern ForexConnectC int TradingSettingsProvider_getCondDistEntryStop(FXCHandle instance, const char *instrument);
extern ForexConnectC int TradingSettingsProvider_getCondDistEntryLimit(FXCHandle instance, const char *instrument);
extern ForexConnectC int TradingSettingsProvider_getMinQuantity(FXCHandle instance, const char *instrument, FXCHandle accountRow);
extern ForexConnectC int TradingSettingsProvider_getMaxQuantity(FXCHandle instance, const char *instrument, FXCHandle accountRow);
extern ForexConnectC int TradingSettingsProvider_getBaseUnitSize(FXCHandle instance, const char *instrument, FXCHandle accountRow);
extern ForexConnectC O2GMarketStatus TradingSettingsProvider_getMarketStatus(FXCHandle instance, const char *instrument);
extern ForexConnectC int TradingSettingsProvider_getMinTrailingStep(FXCHandle instance);
extern ForexConnectC int TradingSettingsProvider_getMaxTrailingStep(FXCHandle instance);
extern ForexConnectC double TradingSettingsProvider_getMMR(FXCHandle instance, const char *instrument, FXCHandle accountRow);
extern ForexConnectC FXCHandle Session_getLoginRules(FXCHandle instance);
extern ForexConnectC void Session_login(FXCHandle instance, const char *user, const char *pwd, const char *url, const char *connection);
extern ForexConnectC void Session_logout(FXCHandle instance);
extern ForexConnectC void Session_subscribeSessionStatus(FXCHandle instance, FXCHandle listener);
extern ForexConnectC void Session_unsubscribeSessionStatus(FXCHandle instance, FXCHandle listener);
extern ForexConnectC FXCHandle Session_getTradingSessionDescriptors(FXCHandle instance);
extern ForexConnectC void Session_setTradingSession(FXCHandle instance, const char *sessionId, const char *pin);
extern ForexConnectC void Session_subscribeResponse(FXCHandle instance, FXCHandle listener);
extern ForexConnectC void Session_unsubscribeResponse(FXCHandle instance, FXCHandle listener);
extern ForexConnectC FXCHandle Session_getRequestFactory(FXCHandle instance);
extern ForexConnectC FXCHandle Session_getResponseReaderFactory(FXCHandle instance);
extern ForexConnectC void Session_sendRequest(FXCHandle instance, FXCHandle request);
extern ForexConnectC FXCHandle Session_getTimeConverter(FXCHandle instance);
extern ForexConnectC O2GPriceUpdateMode Session_getPriceUpdateMode(FXCHandle instance);
extern ForexConnectC void Session_setPriceUpdateMode(FXCHandle instance, O2GPriceUpdateMode mode);
extern ForexConnectC FXCHandle Session_getTableManager(FXCHandle instance);
extern ForexConnectC FXCHandle Session_getTableManagerByAccount(FXCHandle instance, const char *accountID);
extern ForexConnectC DATE Session_getServerTime(FXCHandle instance);
extern ForexConnectC FXCHandle TableManager_getTable(FXCHandle instance, O2GTable tableType);
extern ForexConnectC O2GTableManagerStatus TableManager_getStatus(FXCHandle instance);
extern ForexConnectC void TableManager_lockUpdates(FXCHandle instance);
extern ForexConnectC void TableManager_unlockUpdates(FXCHandle instance);
extern ForexConnectC void Table_subscribeUpdate(FXCHandle instance, O2GTableUpdateType updateType, FXCHandle listener);
extern ForexConnectC void Table_unsubscribeUpdate(FXCHandle instance, O2GTableUpdateType updateType, FXCHandle listener);
extern ForexConnectC void Table_subscribeStatus(FXCHandle instance, FXCHandle listener);
extern ForexConnectC void Table_unsubscribeStatus(FXCHandle instance, FXCHandle listener);
extern ForexConnectC bool Table_isCellChanged(FXCHandle instance, int row, int column);
extern ForexConnectC O2GTableStatus Table_getStatus(FXCHandle instance);
extern ForexConnectC const char *SessionDescriptor_getID(FXCHandle instance);
extern ForexConnectC const char *SessionDescriptor_getName(FXCHandle instance);
extern ForexConnectC const char *SessionDescriptor_getDescription(FXCHandle instance);
extern ForexConnectC bool SessionDescriptor_requiresPin(FXCHandle instance);
extern ForexConnectC int SessionDescriptorCollection_size(FXCHandle instance);
extern ForexConnectC FXCHandle SessionDescriptorCollection_get(FXCHandle instance, int index);
extern ForexConnectC void ValueMap_setString(FXCHandle instance, O2GRequestParamsEnum param, const char *value);
extern ForexConnectC void ValueMap_setDouble(FXCHandle instance, O2GRequestParamsEnum param, double value);
extern ForexConnectC void ValueMap_setInt(FXCHandle instance, O2GRequestParamsEnum param, int value);
extern ForexConnectC void ValueMap_setBoolean(FXCHandle instance, O2GRequestParamsEnum param, bool value);
extern ForexConnectC FXCHandle ValueMap_clone(FXCHandle instance);
extern ForexConnectC void ValueMap_clear(FXCHandle instance);
extern ForexConnectC int ValueMap_getChildrenCount(FXCHandle instance);
extern ForexConnectC FXCHandle ValueMap_getChild(FXCHandle instance, int index);
extern ForexConnectC void ValueMap_appendChild(FXCHandle instance, FXCHandle valueMap);
extern ForexConnectC int TablesUpdatesReader_size(FXCHandle instance);
extern ForexConnectC DATE TablesUpdatesReader_getServerTime(FXCHandle instance);
extern ForexConnectC O2GTableUpdateType TablesUpdatesReader_getUpdateType(FXCHandle instance, int index);
extern ForexConnectC O2GTable TablesUpdatesReader_getUpdateTable(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TablesUpdatesReader_getOfferRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TablesUpdatesReader_getAccountRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TablesUpdatesReader_getOrderRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TablesUpdatesReader_getTradeRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TablesUpdatesReader_getClosedTradeRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TablesUpdatesReader_getMessageRow(FXCHandle instance, int index);
extern ForexConnectC const char *SystemPropertiesReader_findProperty(FXCHandle instance, const char *propertyName);
extern ForexConnectC int SystemPropertiesReader_size(FXCHandle instance);
extern ForexConnectC FXCHandle ResponseReaderFactory_createMarketDataSnapshotReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createTablesUpdatesReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createOffersTableReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createAccountsTableReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createOrdersTableReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createTradesTableReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createClosedTradesTableReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createMessagesTableReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createOrderResponseReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createLastOrderUpdateResponseReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC FXCHandle ResponseReaderFactory_createSystemPropertiesReader(FXCHandle instance, FXCHandle response);
extern ForexConnectC bool ResponseReaderFactory_processMarginRequirementsResponse(FXCHandle instance, FXCHandle response);
extern ForexConnectC const char *Response_getRequestID(FXCHandle instance);
extern ForexConnectC O2GResponseType Response_getType(FXCHandle instance);
extern ForexConnectC const char *Request_getRequestID(FXCHandle instance);
extern ForexConnectC int Request_getChildrenCount(FXCHandle instance);
extern ForexConnectC FXCHandle Request_getChildRequest(FXCHandle instance, int index);
extern ForexConnectC FXCHandle RequestFactory_getTimeFrameCollection(FXCHandle instance);
extern ForexConnectC FXCHandle RequestFactory_createMarketDataSnapshotRequestInstrument(FXCHandle instance, const char *instrument, FXCHandle timeframe, int maxBars);
extern ForexConnectC void RequestFactory_fillMarketDataSnapshotRequestTime(FXCHandle instance, FXCHandle request, DATE dateFrom, DATE dateTo, bool isIncludeWeekends);
extern ForexConnectC FXCHandle RequestFactory_createRefreshTableRequest(FXCHandle instance, O2GTable table);
extern ForexConnectC FXCHandle RequestFactory_createRefreshTableRequestByAccount(FXCHandle instance, O2GTable table, const char *account);
extern ForexConnectC FXCHandle RequestFactory_createOrderRequest(FXCHandle instance, FXCHandle valueMap);
extern ForexConnectC FXCHandle RequestFactory_createValueMap(FXCHandle instance);
extern ForexConnectC const char *RequestFactory_getLastError(FXCHandle instance);
extern ForexConnectC const char *OrderResponseReader_getOrderID(FXCHandle instance);
extern ForexConnectC bool OrderResponseReader_isUnderDealerIntervention(FXCHandle instance);
extern ForexConnectC bool MarketDataSnapshotResponseReader_isBar(FXCHandle instance);
extern ForexConnectC int MarketDataSnapshotResponseReader_size(FXCHandle instance);
extern ForexConnectC DATE MarketDataSnapshotResponseReader_getDate(FXCHandle instance, int index);
extern ForexConnectC int MarketDataSnapshotResponseReader_getVolume(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getBid(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getAsk(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getBidOpen(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getBidHigh(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getBidLow(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getBidClose(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getAskOpen(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getAskHigh(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getAskLow(FXCHandle instance, int index);
extern ForexConnectC double MarketDataSnapshotResponseReader_getAskClose(FXCHandle instance, int index);
extern ForexConnectC int MarketDataSnapshotResponseReader_getLastBarVolume(FXCHandle instance);
extern ForexConnectC DATE MarketDataSnapshotResponseReader_getLastBarTime(FXCHandle instance);
extern ForexConnectC O2GTimeframeUnit Timeframe_getUnit(FXCHandle instance);
extern ForexConnectC int Timeframe_getSize(FXCHandle instance);
extern ForexConnectC const char *Timeframe_getID(FXCHandle instance);
extern ForexConnectC int TimeframeCollection_size(FXCHandle instance);
extern ForexConnectC FXCHandle TimeframeCollection_getByInt(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TimeframeCollection_getByString(FXCHandle instance, const char *id);
extern ForexConnectC const char *TableColumn_getID(FXCHandle instance);
extern ForexConnectC int TableColumnCollection_size(FXCHandle instance);
extern ForexConnectC FXCHandle TableColumnCollection_get(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TableColumnCollection_find(FXCHandle instance, const char *id);
extern ForexConnectC int GenericTableResponseReader_size(FXCHandle instance);
extern ForexConnectC O2GTable GenericTableResponseReader_getType(FXCHandle instance);
extern ForexConnectC FXCHandle GenericTableResponseReader_columns(FXCHandle instance);
extern ForexConnectC const void *GenericTableResponseReader_getCell(FXCHandle instance, int row, int column);
extern ForexConnectC FXCHandle GenericTableResponseReader_getGenericRow(FXCHandle instance, int row);
extern ForexConnectC bool GenericTableResponseReader_isCellValid(FXCHandle instance, int row, int column);
extern ForexConnectC const void *Row_getCell(FXCHandle instance, int column);
extern ForexConnectC bool Row_isCellChanged(FXCHandle instance, int column);
extern ForexConnectC O2GTable Row_getTableType(FXCHandle instance);
extern ForexConnectC FXCHandle Row_columns(FXCHandle instance);
extern ForexConnectC FXCHandle AccountsTable_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TradesTable_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle ClosedTradesTable_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle OffersTable_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle OrdersTable_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle MessagesTable_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle SummaryTable_getRow(FXCHandle instance, int index);
extern ForexConnectC const char *AccountRow_getAccountID(FXCHandle instance);
extern ForexConnectC const char *AccountRow_getAccountName(FXCHandle instance);
extern ForexConnectC const char *AccountRow_getAccountKind(FXCHandle instance);
extern ForexConnectC double AccountRow_getBalance(FXCHandle instance);
extern ForexConnectC double AccountRow_getNonTradeEquity(FXCHandle instance);
extern ForexConnectC double AccountRow_getM2MEquity(FXCHandle instance);
extern ForexConnectC double AccountRow_getUsedMargin(FXCHandle instance);
extern ForexConnectC double AccountRow_getUsedMargin3(FXCHandle instance);
extern ForexConnectC const char *AccountRow_getMarginCallFlag(FXCHandle instance);
extern ForexConnectC DATE AccountRow_getLastMarginCallDate(FXCHandle instance);
extern ForexConnectC const char *AccountRow_getMaintenanceType(FXCHandle instance);
extern ForexConnectC int AccountRow_getAmountLimit(FXCHandle instance);
extern ForexConnectC int AccountRow_getBaseUnitSize(FXCHandle instance);
extern ForexConnectC bool AccountRow_getMaintenanceFlag(FXCHandle instance);
extern ForexConnectC const char *AccountRow_getManagerAccountID(FXCHandle instance);
extern ForexConnectC const char *AccountRow_getLeverageProfileID(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getTradeID(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getAccountID(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getAccountName(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getAccountKind(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getOfferID(FXCHandle instance);
extern ForexConnectC int TradeRow_getAmount(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getBuySell(FXCHandle instance);
extern ForexConnectC double TradeRow_getOpenRate(FXCHandle instance);
extern ForexConnectC DATE TradeRow_getOpenTime(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getOpenQuoteID(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getOpenOrderID(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getOpenOrderReqID(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getOpenOrderRequestTXT(FXCHandle instance);
extern ForexConnectC double TradeRow_getCommission(FXCHandle instance);
extern ForexConnectC double TradeRow_getRolloverInterest(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getTradeIDOrigin(FXCHandle instance);
extern ForexConnectC double TradeRow_getUsedMargin(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getValueDate(FXCHandle instance);
extern ForexConnectC const char *TradeRow_getParties(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getTradeID(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getAccountID(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getAccountName(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getAccountKind(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getOfferID(FXCHandle instance);
extern ForexConnectC int ClosedTradeRow_getAmount(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getBuySell(FXCHandle instance);
extern ForexConnectC double ClosedTradeRow_getGrossPL(FXCHandle instance);
extern ForexConnectC double ClosedTradeRow_getCommission(FXCHandle instance);
extern ForexConnectC double ClosedTradeRow_getRolloverInterest(FXCHandle instance);
extern ForexConnectC double ClosedTradeRow_getOpenRate(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getOpenQuoteID(FXCHandle instance);
extern ForexConnectC DATE ClosedTradeRow_getOpenTime(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getOpenOrderID(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getOpenOrderReqID(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getOpenOrderRequestTXT(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getOpenOrderParties(FXCHandle instance);
extern ForexConnectC double ClosedTradeRow_getCloseRate(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getCloseQuoteID(FXCHandle instance);
extern ForexConnectC DATE ClosedTradeRow_getCloseTime(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getCloseOrderID(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getCloseOrderReqID(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getCloseOrderRequestTXT(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getCloseOrderParties(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getTradeIDOrigin(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getTradeIDRemain(FXCHandle instance);
extern ForexConnectC const char *ClosedTradeRow_getValueDate(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getOfferID(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getInstrument(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getQuoteID(FXCHandle instance);
extern ForexConnectC double OfferRow_getBid(FXCHandle instance);
extern ForexConnectC double OfferRow_getAsk(FXCHandle instance);
extern ForexConnectC double OfferRow_getLow(FXCHandle instance);
extern ForexConnectC double OfferRow_getHigh(FXCHandle instance);
extern ForexConnectC int OfferRow_getVolume(FXCHandle instance);
extern ForexConnectC DATE OfferRow_getTime(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getBidTradable(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getAskTradable(FXCHandle instance);
extern ForexConnectC double OfferRow_getSellInterest(FXCHandle instance);
extern ForexConnectC double OfferRow_getBuyInterest(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getContractCurrency(FXCHandle instance);
extern ForexConnectC int OfferRow_getDigits(FXCHandle instance);
extern ForexConnectC double OfferRow_getPointSize(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getSubscriptionStatus(FXCHandle instance);
extern ForexConnectC int OfferRow_getInstrumentType(FXCHandle instance);
extern ForexConnectC double OfferRow_getContractMultiplier(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getTradingStatus(FXCHandle instance);
extern ForexConnectC const char *OfferRow_getValueDate(FXCHandle instance);
extern ForexConnectC bool OfferRow_isOfferIDValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isInstrumentValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isQuoteIDValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isBidValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isAskValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isLowValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isHighValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isVolumeValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isTimeValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isBidTradableValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isAskTradableValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isSellInterestValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isBuyInterestValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isContractCurrencyValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isDigitsValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isPointSizeValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isSubscriptionStatusValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isInstrumentTypeValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isContractMultiplierValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isTradingStatusValid(FXCHandle instance);
extern ForexConnectC bool OfferRow_isValueDateValid(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getOrderID(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getRequestID(FXCHandle instance);
extern ForexConnectC double OrderRow_getRate(FXCHandle instance);
extern ForexConnectC double OrderRow_getExecutionRate(FXCHandle instance);
extern ForexConnectC double OrderRow_getRateMin(FXCHandle instance);
extern ForexConnectC double OrderRow_getRateMax(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getTradeID(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getAccountID(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getAccountName(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getOfferID(FXCHandle instance);
extern ForexConnectC bool OrderRow_getNetQuantity(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getBuySell(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getStage(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getType(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getStatus(FXCHandle instance);
extern ForexConnectC DATE OrderRow_getStatusTime(FXCHandle instance);
extern ForexConnectC int OrderRow_getAmount(FXCHandle instance);
extern ForexConnectC double OrderRow_getLifetime(FXCHandle instance);
extern ForexConnectC double OrderRow_getAtMarket(FXCHandle instance);
extern ForexConnectC int OrderRow_getTrailStep(FXCHandle instance);
extern ForexConnectC double OrderRow_getTrailRate(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getTimeInForce(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getAccountKind(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getRequestTXT(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getContingentOrderID(FXCHandle instance);
extern ForexConnectC int OrderRow_getContingencyType(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getPrimaryID(FXCHandle instance);
extern ForexConnectC int OrderRow_getOriginAmount(FXCHandle instance);
extern ForexConnectC int OrderRow_getFilledAmount(FXCHandle instance);
extern ForexConnectC bool OrderRow_getWorkingIndicator(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getPegType(FXCHandle instance);
extern ForexConnectC double OrderRow_getPegOffset(FXCHandle instance);
extern ForexConnectC DATE OrderRow_getExpireDate(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getValueDate(FXCHandle instance);
extern ForexConnectC const char *OrderRow_getParties(FXCHandle instance);
extern ForexConnectC const char *MessageRow_getMsgID(FXCHandle instance);
extern ForexConnectC DATE MessageRow_getTime(FXCHandle instance);
extern ForexConnectC const char *MessageRow_getFrom(FXCHandle instance);
extern ForexConnectC const char *MessageRow_getType(FXCHandle instance);
extern ForexConnectC const char *MessageRow_getFeature(FXCHandle instance);
extern ForexConnectC const char *MessageRow_getText(FXCHandle instance);
extern ForexConnectC const char *MessageRow_getSubject(FXCHandle instance);
extern ForexConnectC bool MessageRow_getHTMLFragmentFlag(FXCHandle instance);
extern ForexConnectC double AccountTableRow_getEquity(FXCHandle instance);
extern ForexConnectC double AccountTableRow_getDayPL(FXCHandle instance);
extern ForexConnectC double AccountTableRow_getUsableMargin(FXCHandle instance);
extern ForexConnectC double AccountTableRow_getGrossPL(FXCHandle instance);
extern ForexConnectC double TradeTableRow_getPL(FXCHandle instance);
extern ForexConnectC double TradeTableRow_getGrossPL(FXCHandle instance);
extern ForexConnectC double TradeTableRow_getClose(FXCHandle instance);
extern ForexConnectC double TradeTableRow_getStop(FXCHandle instance);
extern ForexConnectC double TradeTableRow_getLimit(FXCHandle instance);
extern ForexConnectC double ClosedTradeTableRow_getPL(FXCHandle instance);
extern ForexConnectC double OfferTableRow_getPipCost(FXCHandle instance);
extern ForexConnectC double OrderTableRow_getStop(FXCHandle instance);
extern ForexConnectC double OrderTableRow_getLimit(FXCHandle instance);
extern ForexConnectC int OrderTableRow_getStopTrailStep(FXCHandle instance);
extern ForexConnectC double OrderTableRow_getStopTrailRate(FXCHandle instance);
extern ForexConnectC const char *SummaryTableRow_getOfferID(FXCHandle instance);
extern ForexConnectC int SummaryTableRow_getDefaultSortOrder(FXCHandle instance);
extern ForexConnectC const char *SummaryTableRow_getInstrument(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getSellNetPL(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getSellAmount(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getSellAvgOpen(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getBuyClose(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getSellClose(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getBuyAvgOpen(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getBuyAmount(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getBuyNetPL(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getAmount(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getGrossPL(FXCHandle instance);
extern ForexConnectC double SummaryTableRow_getNetPL(FXCHandle instance);
extern ForexConnectC FXCHandle AccountsTableResponseReader_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle TradesTableResponseReader_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle ClosedTradesTableResponseReader_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle OffersTableResponseReader_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle OrdersTableResponseReader_getRow(FXCHandle instance, int index);
extern ForexConnectC FXCHandle MessagesTableResponseReader_getRow(FXCHandle instance, int index);
#ifdef __cplusplus
}
#endif
  